/****************************************************************************
 ****************************************************************************
 *
 * ac.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef YAWICA_AC_H
#define YAWICA_AC_H

#ifdef YAWICA_DEBUG
#define AC_STATISTICS
#endif /* YAWICA_DEBUG */

#define AC_MODE_READ			1
#define AC_MODE_WRITE			2

struct arithmetic_codec
	{
	unsigned char			*data;
	int				size;
	int				ofs;
	unsigned int			base;
	unsigned int			length;
	};

struct adaptive_codec
	{
	struct arithmetic_codec		*arc;
	unsigned int			prob0;
	unsigned int			bitcount;
	unsigned int			bitcount0;
	unsigned int			update_interval;
	unsigned int			adaptive_shrink;
	unsigned int			bits_per_update;
	unsigned int			bits_until_update;
#ifdef AC_STATISTICS
	unsigned int			bitcount_all;
	unsigned int			bitcount0_all;
	double				size;
#endif /* AC_STATISTICS */
	};

struct ac
	{
	struct arithmetic_codec		arc;
	struct adaptive_codec		*adc;
	int				bits;
	int				bitlimit;
	int				aclimit;
	int				mode;
	int				ctxs;
	};

extern int				ac_get_flush_bytes(void);
extern unsigned char 			*ac_init(struct ac *, unsigned char *, int, int, int, int, int);
extern void				ac_init2(struct ac *, int, int, int);
extern void				ac_flush(struct ac *);
extern void				ac_deinit(struct ac *);
extern int				ac_read_bit(struct ac *);
extern int				ac_write_bit(struct ac *, int);
extern int				ac_read_value(struct ac *, int);
extern int				ac_write_value(struct ac *, int, int);
extern int				ac_ctx_reset(struct ac *, int, int, int);
extern int				ac_ctx_read_bit(struct ac *, int);
extern int				ac_ctx_write_bit(struct ac *, int, int);
extern unsigned char			*ac_get_data(struct ac *);
extern int				ac_get_uncompressed_bits(struct ac *);
extern int				ac_get_compressed_bytes(struct ac *);



#endif /* !YAWICA_AC_H */
/******************************************************** Karsten Scheibler */
