/****************************************************************************
 ****************************************************************************
 *
 * file.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef YAWICA_FILE_H
#define YAWICA_FILE_H

struct transform;
struct codec;

struct file
	{
	unsigned char			*data;
	int				size;
	int				bitlimit;
	int				xres;
	int				yres;
	int				level;
	int				codec;
	int				msb;
	int				shift;
	int				wavelet;
	};

extern int				file_get_header_size(void);
extern void				file_init(struct file *, struct transform *, struct codec *);
extern void				file_read(struct file *, char *);
extern void				file_write(struct file *, char *);
extern unsigned char			*file_get_data(struct file *);
extern int				file_get_size(struct file *);
extern int				file_get_bitlimit(struct file *);
extern int				file_get_xres(struct file *);
extern int				file_get_yres(struct file *);
extern int				file_get_level(struct file *);
extern int				file_get_codec(struct file *);
extern int				file_get_msb(struct file *);
extern int				file_get_shift(struct file *);
extern int				file_get_wavelet(struct file *);



#endif /* !YAWICA_FILE_H */
/******************************************************** Karsten Scheibler */
