/****************************************************************************
 ****************************************************************************
 *
 * pcoeff.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef YAWICA_PCOEFF_H
#define YAWICA_PCOEFF_H

struct pcoeff
	{
	unsigned int			magn:32;
	unsigned int			sign:1;
	unsigned int			done:1;
	unsigned int			valid:5;
	unsigned int			lsb:5;
	unsigned int			msb:5;
	unsigned int			ctx:4;
	unsigned int			dist:2;
	unsigned int			reserved:9;
	};

extern void				pcoeff_set(struct pcoeff *, double, int);
extern double				pcoeff_get(struct pcoeff *);
extern int				pcoeff_already_finished(struct pcoeff *, int);
extern int				pcoeff_already_significant(struct pcoeff *, int);
extern int				pcoeff_get_sign(struct pcoeff *);
extern int				pcoeff_get_msb(struct pcoeff *);
extern int				pcoeff_get_significance(struct pcoeff *, int);
extern int				pcoeff_get_magnitude(struct pcoeff *, int);
extern void				pcoeff_set_significance_and_sign(struct pcoeff *, int, int);
extern void				pcoeff_set_magnitude(struct pcoeff *, int, int);
extern int				pcoeff_ctx_get1(struct pcoeff *);
extern int				pcoeff_ctx_get2(struct pcoeff *);
extern int				pcoeff_ctx_already_done(struct pcoeff *);
extern void				pcoeff_ctx_update(struct pcoeff *);
extern void				pcoeff_ctx_set_significance(struct pcoeff *);
extern void				pcoeff_ctx_set_magnitude(struct pcoeff *, int);
extern void				pcoeff_ctx_set_done(struct pcoeff *);
extern int				pcoeff_dist_get(struct pcoeff *);
extern void				pcoeff_dist_set(struct pcoeff *, int);



#endif /* !YAWICA_PCOEFF_H */
/******************************************************** Karsten Scheibler */
