/****************************************************************************
 ****************************************************************************
 *
 * picture.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef YAWICA_PICTURE_H
#define YAWICA_PICTURE_H

#include "pcoeff.h"

#define PICTURE_MODE_DOUBLE			1
#define PICTURE_MODE_PCOEFF			2

union coefficient
	{
	double				d;
	struct pcoeff			pcf;
	};

struct picture
	{
	union coefficient		*cft;
	int				mode;
	int				xres;
	int				yres;
	int				shift;
	};

extern void				picture_init(struct picture *, int, int);
extern void				picture_deinit(struct picture *);
extern void				picture_write_uchar(struct picture *, unsigned char *);
extern void				picture_read_uchar(struct picture *, unsigned char *);
extern union coefficient		*picture_get_coefficient(struct picture *, int);
extern int				picture_get_xres(struct picture *);
extern int				picture_get_yres(struct picture *);
extern int				picture_get_shift(struct picture *);
extern void				picture_set_mode(struct picture *, int);
extern void				picture_set_shift(struct picture *, int);



#endif /* !YAWICA_PICTURE_H */
/******************************************************** Karsten Scheibler */
