/****************************************************************************
 ****************************************************************************
 *
 * transform.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef YAWICA_TRANSFORM_H
#define YAWICA_TRANSFORM_H

#define TRANSFORM_NONE			0
#define TRANSFORM_WAVELET_HAAR		1
#define TRANSFORM_SP			2
#define TRANSFORM_WAVELET_53		3
#define TRANSFORM_WAVELET_53L		4
#define TRANSFORM_WAVELET_97		5

struct picture;

struct transform
	{
	struct picture			*pic;
	int				level;
	int				wavelet;
	};

extern int				transform_get_max_level(int, int, int);
extern int				transform_get_wavelet_number(char *);
extern void				transform_init(struct transform *, struct picture *, int, int);
extern void				transform_forward(struct transform *);
extern void				transform_reverse(struct transform *);
extern void				transform_convert(struct transform *);
extern void				transform_unconvert(struct transform *);
extern struct picture			*transform_get_picture(struct transform *);
extern int				transform_get_level(struct transform *);
extern int				transform_get_wavelet(struct transform *);



#endif /* !YAWICA_TRANSFORM_H */
/******************************************************** Karsten Scheibler */
